



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ThreadPoolExecutor的学习</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ThreadPoolExecutor的学习</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:17:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java多线程之ThreadPoolExecutor</p>
<p>线程池的作用就是使用更少的线程, 来执行更多的任务, 以达到线程的充分利用. 从ThreadPoolExecutor类的构造方法学习:</p>
<div>
<pre class="prettyprint linenums">/** * Creates a new {@code ThreadPoolExecutor} with the given initial * parameters and default rejected execution handler. * * @param corePoolSize the number of threads to keep in the pool, even *        if they are idle, unless {@code allowCoreThreadTimeOut} is set * @param maximumPoolSize the maximum number of threads to allow in the *        pool * @param keepAliveTime when the number of threads is greater than *        the core, this is the maximum time that excess idle threads *        will wait for new tasks before terminating. * @param unit the time unit for the {@code keepAliveTime} argument * @param workQueue the queue to use for holding tasks before they are *        executed.  This queue will hold only the {@code Runnable} *        tasks submitted by the {@code execute} method. * @param threadFactory the factory to use when the executor *        creates a new thread * @throws IllegalArgumentException if one of the following holds:&lt;br&gt; *         {@code corePoolSize &lt; 0}&lt;br&gt; *         {@code keepAliveTime &lt; 0}&lt;br&gt; *         {@code maximumPoolSize &lt;= 0}&lt;br&gt; *         {@code maximumPoolSize &lt; corePoolSize} * @throws NullPointerException if {@code workQueue} *         or {@code threadFactory} is null */public ThreadPoolExecutor(int corePoolSize,
                              int maximumPoolSize,
                              long keepAliveTime,
                              TimeUnit unit,
                              BlockingQueue&lt;Runnable&gt; workQueue) {
        this(corePoolSize, maximumPoolSize, keepAliveTime, unit, workQueue,
             Executors.defaultThreadFactory(), defaultHandler);
    }</pre>
</div>
<p>ThreadPoolExecutor的具体执行流程有四步:</p>
<p>(1) 当目前执行线程的总数小于核心线程大小corePoolSize时,&nbsp; 提交了任务, 会立马新建一个线程来执行提交的任务.</p>
<p>(2) 当目前执行线程的总数达到了核心线程大小corePoolSize时, 就会将当前提交的任务存到缓存队列中</p>
<p>(3) 当缓存队列满了之后, 如果当前线程的总数小于maximumPoolSize时, 此时就会新建线程进行救急处理, 提交的任务会立马执行.</p>
<p>(4) 当线程数达到maximumPoolSize后, 就会采用拒绝策略拒绝任务</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnjk2k8.html">ios 获取手机的IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77m0kq.html">python基础3（元祖、字典、深浅copy、集合、文件处理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3rleq.html">C&plus;&plus;宽窄字符串转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnon329.html">Python框架之Tornado（四）源码之褪去模板外衣</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ov1o9.html">AJAX练习&lpar;一&rpar;：制作可以自动校验的表单（从原理上分析ajax的作用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjpp49.html">phonegap&lowbar;android配置文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd13jd8.html">mvn 安装ojdbc6&period;jar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1xgeq.html">【POJ1082】Calendar Game （博弈）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1kxpx9.html">block代码块介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvym0q.html">bzoj3541&colon; Spoj59 Bytelandian Information Agency</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdmgkk8.html">简单html以及css的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7d038.html">UIWebvView 解决onClick 延迟相应问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1krl469.html">让低版本的IE浏览器 强制渲染为IE8 或者 以上 浏览器模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjlkp38.html">PHP部分--文件上传、客户端和服务器端加限制、抓取错误信息、完整步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2emloq.html">js实现输入某串数字，构建完全二叉树，并判断是否为二叉搜索树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21yro9.html">mRNA文库构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv02zk8.html">sparkStreaming运行yarn，提交任务报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gz7o0q.html">jQuery-2&period;DOM---节点的复制与替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllrm31q.html">ASP&period;NET MVC AntiForgeryToken</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ozzl9.html">51nod 1020 逆序排列</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1e1wk9.html">ORACLE数据库创建用户名和表空间</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnmn7pq.html">转：python webdriver API 之调用 JavaScript</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv517jq.html">&lbrack;原创&rsqb;java WEB学习笔记54：Struts2学习之路---概述，环境的搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1gk439.html">Android -- 自定义View（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10og69.html">java中从Spring、Hibernate和Struts框架的action、service和dao三层结构异常处理体系设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v7d6o8.html">夺命雷公狗---DEDECMS----20dedecms取出栏目页对应的内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm14d49.html">Html基础知识讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xrj508.html">NOIP201405生活大爆炸版石头剪刀布</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1ejjj9.html">co css规范</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k102659.html">网上书城分类Category模块</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
